﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
using namespace std;
#define ll size_t

ll pw(ll a, ll n) {
    ll res = 1;
    for (int i = 0; i < n; i++) {
        res = a * res;
        if (res < 0)
            return -1;
    }
    return res;
}

ll ans = 0;
map<pair<pair<ll, ll>, pair<ll, ll>>, ll> mp;

ll solve(ll a, ll b, ll mn_a, ll mn_b) {
    if (mp.find({ {a, b}, {mn_a, mn_b} }) != mp.end()) {
        ans += mp[{{a, b}, { mn_a, mn_b }}];
        return mp[{{a, b}, { mn_a, mn_b }}];
    }
    if (a == 0 && b == 0) {
        ans++;
        return 1;
    }
    ll res = 0;
    for (int i = mn_a; i <= a; i++) {
        if (i == mn_a) {
            for (int j = mn_b; j <= b; j++) {
                if (i + j != 0)
                    res += solve(a - i, b - j, i, j);
            }
        }
        else {
            for (int j = 0; j <= b; j++)
                res += solve(a - i, b - j, i, j);
        }
    }
    mp[{{a, b}, { mn_a, mn_b }}] = res;
    return res;
}

int main()
{
    ll n;
    cin >> n;
    ll sqr = -1;
    vector<double> rs = {1e+18, 1e+09, 1e+06, 31622.8, 3981.07, 1000, 372.759, 177.828, 100, 63.0957, 43.2876, 31.6228, 24.2446, 19.307, 15.8489, 13.3352, 11.4505, 10 };
    for (int i = 1; i <= 30; i++) {
        ll l = 1, r = 10;
        if (i - 1 < rs.size())
            r = rs[i - 1];
        while (r - l > 1) {
            ll m = (l + r) / 2;
            ll pw_res = pw(m, i);
            if (pw_res <= n && pw_res != -1)
                l = m;
            else
                r = m;
        }
        if (pw(l, i) == n)
            sqr = i;
    }
    if (sqr == -1)
        return -1;
    vector<ll> res = { 2, 9, 31, 109, 339, 1043, 2998, 8406, 22652, 59521, 151958, 379693, 927622, 2224235, 5236586, 12130780, 27669593, 62229990, 138095696, 302673029, 655627975, 1404599867, 2977831389, 6251060785, 12999299705, 26791990052, 54750235190, 110977389012, 223204459265 };
    cout << res[sqr - 1] - 1 << "\n";
}
