#include <iostream>
#include <map>
#define ll long long

using namespace std;

ll pow(ll a, int b, ll n) {
    __int128 r = 1;
    while (b--) {
        r *= a;
        if (r >= n) return false;
    }
    return true;
}

ll powfff(ll a, int b) {
    int r = 1;
    while (b--) r *= a;
    return r;
}

bool check_power(ll n, int k) {
    ll l = 1, r = n;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (pow(m, k, n)) {
            l = m;
        } else {
            r = m;
        }
    }
    return powfff(r, k) == n;
}

struct pos {
    int a, b, mp, mq;
};

pos frompair(pair<pair<int, int>, pair<int, int>> t) {
    return {t.first.first, t.first.second, t.second.first, t.second.second};
}

pair<pair<int, int>, pair<int, int>> frompos(pos t) {
    return {{t.a, t.b}, {t.mp, t.mq}};
}

map<pair<pair<int, int>, pair<int, int>>, ll> mem;

ll func(pos x) {
    if (mem.find(frompos(x)) != mem.end()) return mem[frompos(x)];
    if (x.a == 0 && x.b == 0) return 1;
    ll res = 0;
    for (int np = x.mp; np <= x.a; np++) {
        int ttt = 0;
        if (np == x.mp) ttt = x.mq;
        for (int nq = ttt; nq <= x.b; nq++) {
            if (np == 0 && nq == 0) continue;
            res += func({x.a - np, x.b - nq, np, nq});
        }
    }
    mem[frompos(x)] = res;
    return res;
}

int main() {
    ll n; int k; cin >> n;
    check_power(100, 2);
    for (k = 25; k > 0; k--) {
        if (check_power(n, k)) break;
    }
    pos q = {k, k, 0, 0};
    cout << func(q) - 1 << '\n';
}
