def is_prime(num):
    if num<2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True

def non_prime_partitions(n):
    cache = {}

    def helper(target, start):
        if target == 0:
             return[[]]
        if (target, start) in cache:
            return cache[(target, start)]

        result = []
        for i in range(start, target + 1):
            if is_prime(i):
                continue
            for partitions in helper(target - i, i):
                result.append([i] + partitions)

        cache[(target, start)] = result
        return result

    partitions = helper(n, 1)
    for partitions in partitions:
        print('+'.join(map(str, partitions)))


n = int(input())
non_prime_partitions(n)
