
#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <string>

typedef long long LL;

std::set<std::string> OutStrs;

bool IsSimple( int A )
{
  const double sqrtA = sqrt(A);

  for (int i = 2; i <= sqrtA; i++)
    if (A % i == 0)
      return 0;

  return 1;
}

void StoreA( const std::vector<int> &A )
{
  if (A.size() < 1)
    return;

  std::string NewStr = std::to_string(A[0]);

  for (int i = 1; i < (int)A.size(); i++)
    NewStr += "+" + std::to_string(A[i]);

  OutStrs.emplace(NewStr);
}

void WorkRec( const std::vector<int> &A, int HasSimple ) // Provided 'A' has only simple numbers
{
  if (!HasSimple)
    StoreA(A);

  if (A.size() <= 2)
    return;

  int Max = A.back();

  for (int i = A.size() - 2; i >= 0/* && A[i + 1] + A[i] <= Max*/; i--)
  {
    std::vector<int> NewA(A.begin(), A.begin() + i);

    int NewValue = A[i + 1] + A[i];

    
    NewA.push_back(NewValue);


    for (auto it = A.begin() + i + 2; it != A.end(); ++it) // Kal
      NewA.push_back(*it);

    if (NewValue > NewA.back())
      continue;

    WorkRec(NewA, IsSimple(NewValue));
  }
}

int main( void )
{
  int n;

  std::cin >> n;

  std::vector<int> Ns(n);

  for (int i = 0; i < n; i++)
    Ns[i] = 1;

  WorkRec(Ns, 0);

  for (const std::string &Str : OutStrs)
    std::cout << Str << "\n";

  return 0;
}

