def gen_complicated_partitions(n):
    if n == 0:
        yield [0]
    else:
        for i in range(1, n//2+1):
            if not is_prime(i):
                for part in gen_complicated_partitions(n-i):
                    yield [i]+part
        if n > 0:
            yield [n]

def is_prime(n):
    if n in (2, 3):
        return True

    if n % 2 == 0 or n % 3 == 0:
        return False

    i = 5
    while i * i <= n:
        if n % i == 0 or n % (i + 2) == 0:
            return False
        i += 6

    return True

if __name__ == "__main__":
    n = int(input().strip())
    for part in gen_complicated_partitions(n):
        print(*part, sep='+')