SIMPLE_NUMS = (2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67)
ready_nums = {}

def find_ans(n):
    if n == 1:
        return ['1']
    if n in ready_nums:
        return ready_nums[n]
    variants = []
    for i in range(1, n // 2 + 1):
        if i not in SIMPLE_NUMS and n - i not in SIMPLE_NUMS:
            variants.append(str(i) + '+' + str(n - i))
        a = find_ans(i)
        b = find_ans(n - i)
        for j in a:
            for k in b:
                variants.append(j + '+' + k)
    res = list(set(variants))
    ready_nums[n] = res
    return res

def merge_sort(nums):
    if len(nums) > 1:
        mid = len(nums) // 2
        nums1 = nums[:mid]
        nums2 = nums[mid:]
        merge_sort(nums1)
        merge_sort(nums2)
        i = j = k = 0
        while i < len(nums1) and j < len(nums2):
            if nums1[i] < nums2[j]:
                nums[k] = nums1[i]
                i += 1
                k += 1
            else:
                nums[k] = nums2[j]
                j += 1
                k += 1
        while i < len(nums1):
            nums[k] = nums1[i]
            i += 1
            k += 1
        while j < len(nums2):
            nums[k] = nums2[j]
            j += 1
            k += 1

n = int(input())
res = find_ans(n)
answers = set()
for i in res:
    ans = [int(x) for x in i.split('+')]
    merge_sort(ans)
    if tuple(ans) not in answers:
        print('+'.join([str(x) for x in ans]))
        answers.add(tuple(ans))