def find_distance(L, R, n, d):
    # Инициализация начальных значений
    start = 0  # начальная точка дистанции
    finish = 0  # конечная точка дистанции
    min_distance = float('inf')  # минимальное расстояние от финиша до начала дорожки

    # Проверка возможных вариантов
    for i in range(n):
        # Проверка дистанции от начала дорожки до i-го дерева
        dist_start = d[i]
        if L <= dist_start <= R:
            # Проверка дистанции от i-го дерева до конца дорожки
            for j in range(i + 1, n):
                dist_finish = d[j] - d[i]
                if L <= dist_finish <= R and dist_start + dist_finish < min_distance:
                    start = dist_start
                    finish = dist_finish
                    min_distance = dist_start + dist_finish

    # Возвращаем найденные значения
    return start, start + finish

L = int(input("Введите нижнюю границу длины дистанции: "))
R = int(input("Введите верхнюю границу длины дистанции: "))
n = int(input("Введите количество деревьев: "))

d = []
for i in range(n):
    dist = int(input("Введите расстояние до дерева {}: ".format(i+1)))
    d.append(dist)

start, finish = find_distance(L, R, n, d)
print("Начало дистанции: ", start, "м")
print("Конец дистанции: ", finish, "м")