import math

def is_prime(num):
    if num == 1:
        return False
    if num == 2:
        return True
    if num % 2 == 0:
        return False
    sqrt_num = math.sqrt(num)
    for i in range(3, int(sqrt_num) + 1, 2):
        if num % i == 0:
            return False
    return True

def find_partitions(n):
    def dfs(current_sum, path):
        if current_sum == n:
            nonlocal result
            if not any(is_prime(i) for i in path):
                result.append('+'.join(map(str, path)))
        elif current_sum < n:
            for i in range(1, n - current_sum + 1):
                dfs(current_sum + i, path + [i])

    result = []
    dfs(0, [])
    return result

def find_n_partitions(n):
    return find_partitions(n)

if __name__ == "__main__":
    n = int(input())
    partitions = find_n_partitions(n)
    print("\n".join(partitions))