def is_prime(num):
    """
    Функция для проверки, является ли число простым.
    """
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def non_prime_partitions(n, start=2):
    """
    Функция для генерации непростых разбиений числа n.
    """
    results = []

    # Базовый случай: если n равно 0, возвращаем пустое разбиение
    if n == 0:
        return [[]]

    # Рекурсивно генерируем разбиения, начиная с числа start
    for i in range(start, n + 1):
        if not is_prime(i):
            # Генерируем разбиения для числа n - i
            sub_partitions = non_prime_partitions(n - i, i)

            # Добавляем число i ко всем разбиениям n - i
            for partition in sub_partitions:
                results.append([i] + partition)

    return results

n = int(input())
partitions = non_prime_partitions(n)

for partition in partitions:
    print("+".join(map(str, partition)))