def sieve_of_eratosthenes(limit):
    primes = [True] * (limit + 1)
    primes[0] = primes[1] = False

    for i in range(2, int(limit**0.5) + 1):
        if primes[i]:
            for j in range(i*i, limit+1, i):
                primes[j] = False

    return [x for x in range(limit + 1) if primes[x]]

def is_prime(num, primes):
    if num < 2:
        return False
    return num in primes

def count_non_prime_partitions(n):
    count = 0
    primes = set(sieve_of_eratosthenes(n))

    def helper(n, largest):
        nonlocal count
        if n == 0:
            count += 1
            return
        for i in range(1, largest + 1):
            if not is_prime(i, primes) and i <= n:
                helper(n - i, i)

    helper(n, n)
    return count

def main():
    n = int(input())

    result = count_non_prime_partitions(n)
    print(result)

if __name__ == "__main__":
    main()