def count_non_prime_partitions(n):
    primes = [True] * (n + 1)
    primes[0] = primes[1] = False

    for i in range(2, int(n**0.5) + 1):
        if primes[i]:
            for j in range(i*i, n+1, i):
                primes[j] = False

    dp = [0] * (n + 1)
    dp[0] = 1

    for i in range(1, n + 1):
        for j in range(i, n + 1):
            if not primes[i]:
                dp[j] += dp[j - i]

    return dp[n]

def main():
    n = int(input())
    result = count_non_prime_partitions(n)
    print(result)

if __name__ == "__main__":
    main()